####################################################################
#                                                                  #
# NAME:      Sample Solution                                       #
#                                                                  #
####################################################################
#====================================================================
#       Static data allocation and initialization
#====================================================================
.data
num:	.asciiz "5936"
nl:		.asciiz "\n"

#====================================================================
#       Program text
#====================================================================

.text
.globl main

main:
# Register usage:
#		$a0 :	char *s, pointer to the next character
#		$t0 :	bool neg, 1 if negative
#		$t1 :	int n, absolute value of the number
#		$t2 :	char c, holds the current character
#		$t3 :	temp
#		$v0 :	is not used since it needs to be used to print the value

		# Initialize the values and then
		# load the first character of the string. If it is a '+' or '-' then
		# skip the character and set neg ($t0) correctly.
		la $a0, num				# s = num
		li $t0, 0				# neg = 0
		li $t1, 0				# n = 0
		lb $t2, 0($a0)			# c = *s
		addiu $a0, $a0, 1		# ++s

		# Check for '+'
		li $t3, 0x2b			# temp = '+'
		bne $t2, $t3, next		# if (c == temp) goto next
		lb $t2, 0($a0)			# c = *s
		addiu $a0, $a0, 1		# ++s
		b meat					# goto meat (why not a jump here?)
		
		# Check for '-'
next:	li $t3, 0x2d			# temp = '-'
		bne $t2, $t3, meat		# if (c != temp) goto meat
		li $t0, 1				# neg = true
		lb $t2, 0($a0)			# c = *s
		addiu $a0, $a0, 1		# ++s

# This is the meat of the loop.
# First add the current value, then check if the next character is 0.
# If it is, then exit the loop. If it isn't, then multiply the t1 by
# 10, update the pointer and continue the loop.
meat:	addi $t3, $t2, -48		# temp = c - '0'
		add $t1, $t1, $t3		# n = n + temp
		lb $t2, 0($a0)			# c = *s
		beqz $t2, print			# if (!c) goto print
		li $t3, 10				# temp = 10
		mul $t1, $t1, $t3		# n = n * temp
		addiu $a0, $a0, 1		# ++s
		b meat					# goto meat, (Why didn't I use a jump here?)

# Print the integer and a newline
print:	beqz $t0, doit			# if (neg) goto doit, it's positive
		not $t1, $t1			# perform 1s compliment
		addi $t1, $t1, 1		# make that 2s compliment
doit:	li $v0, 1				# v0 = 1, print an int
		move $a0, $t1			# a0 = t1, the int to print
		syscall					# print it
		li $v0, 4				# v0 = 11, print a char
		la $a0, nl				# a0 = nl
		syscall					# print "\n"
        jr      $ra             # return
.end main
